/*
**  display.c
**  (c)Huron Net Works, Inc., 2005
**
**  LCD Display Handler
**
**	9/8/05	-- Original
**
**  TABS 5, 9
*/
#include	"hardware.h"
#include	"externs.h"
/*
**	Display Strings
*/
/* Ruler							 1234567890123456		*/
const unsigned char	ds_0_1_1[]	=	"Selftest        " ;
const unsigned char	ds_0_1_2[]	=	"Run             " ;

const unsigned char ds_1_1_1[]	=	"Quick Config    " ;
const unsigned char	ds_1_2_1[]	=	"Normal          " ;
const unsigned char ds_1_2_2[]	=	"Quiet           " ;
const unsigned char ds_1_2_3[]	=	"Loud            " ;
const unsigned char ds_1_2_4[]	=	"Tracking        " ;
const unsigned char ds_1_2_5[]	=	"Demo            " ;
const unsigned char ds_1_2_6[]	=	"User 1          " ;
const unsigned char ds_1_2_7[]	=	"User 2          " ;
const unsigned char ds_1_2_8[]	=	"User 3          " ;
const unsigned char ds_1_2_9[]	=	"Test Mode       " ;

const unsigned char	ds_2_1_1[]	=	"PA Time         " ;
const unsigned char	ds_2_2_1[]	=	"2 sec.          " ;
const unsigned char ds_2_2_2[]	=	"5 sec.          " ;
const unsigned char ds_2_2_3[]	=	"10 sec.         " ;
const unsigned char	ds_2_2_4[]	=	"Continuous      " ;
const unsigned char ds_2_2_5[]	=	"Disable         " ;

const unsigned char	ds_3_1_1[]	=	"PA Repeat       " ;
const unsigned char ds_3_2_1[]	=	"15 sec.         " ;
const unsigned char ds_3_2_2[]	=	"30 sec.         " ;
const unsigned char	ds_3_2_3[]	=	"1 min.          " ;
const unsigned char ds_3_2_4[]	=	"5 min.          " ;
const unsigned char	ds_3_2_5[]	=	"15 min.         " ;
const unsigned char ds_3_2_6[]	=	"Disable         " ;

const unsigned char ds_4_1_1[]	=	"PA Sound        " ;
const unsigned char ds_4_2_1[]	=	"Low             " ;
const unsigned char	ds_4_2_2[]	=	"High            " ;
const unsigned char	ds_4_2_3[]	=	"Disable         " ;

const unsigned char ds_5_1_1[]	=	"911 Call Delay  " ;
const unsigned char	ds_5_2_1[]	=	"0 sec.          " ;
const unsigned char ds_5_2_2[]	=	"5 sec.          " ;
const unsigned char ds_5_2_3[]	=	"10 sec.         " ;
const unsigned char ds_5_2_4[]	=	"15 sec.         " ;
const unsigned char	ds_5_2_5[]	=	"60 sec.         " ;
const unsigned char ds_5_2_6[]	=	"Disable         " ;

const unsigned char ds_6_1_1[]	=	"Speaker Volume  " ;
const unsigned char ds_6_2_1[]	=	"Low             " ;
const unsigned char ds_6_2_2[]	=	"Medium          " ;
const unsigned char	ds_6_2_3[]	=	"High            " ;
const unsigned char ds_6_2_4[]	=	"Disable         " ;

const unsigned char	ds_7_1_1[]	=	"GPS Report      " ;
const unsigned char	ds_7_2_1[]	=	"911 Call Only   " ;
const unsigned char ds_7_2_2[]	=	"2 min.          " ;
const unsigned char	ds_7_2_3[]	=	"5 min.          " ;
const unsigned char ds_7_2_4[]	=	"10 min.         " ;
const unsigned char ds_7_2_5[]	=	"15 min.         " ;
const unsigned char ds_7_2_6[]	=	"1 hr.           " ;
const unsigned char	ds_7_2_7[]	=	"4 hr.           " ;

const unsigned char	ds_8_1_1[]	=	"GPS Power       " ;
const unsigned char ds_8_2_1[]	=	"Always On       " ;
const unsigned char ds_8_2_2[]	=	"Standby         " ;
const unsigned char ds_8_2_3[]	=	"Disable         " ;

const unsigned char	ds_9_1_1[]	=	"SMS Services    " ;
const unsigned char	ds_9_2_1[]	=	"Send & Recv     " ;
const unsigned char ds_9_2_2[]	=	"Disable Inbd    " ;
const unsigned char	ds_9_2_3[]	=	"Disable GPS Quer" ;

const unsigned char	ds_10_1_1[]	=	"SMS Alert       " ;
const unsigned char	ds_10_2_1[]	=	"Vibrate         " ;
const unsigned char ds_10_2_2[]	=	"Sound Only      " ;
const unsigned char ds_10_2_3[]	=	"Vibrate & Sound " ;
const unsigned char	ds_10_2_4[] =	"Disable Notify  " ;

const unsigned char	ds_11_1_1[] =	"Clock Display   " ;
const unsigned char ds_11_2_1[]	=	"12 hr. AM/PM    " ;
const unsigned char ds_11_2_2[]	=	"24 Hour         " ;

const unsigned char ds_12_1_1[]	=	"Clock Time Zone " ;
const unsigned char ds_12_2_1[] =	"EST             " ;
const unsigned char ds_12_2_2[] =	"EDT             " ;

const unsigned char ds_13_1_1[]	=	"SMS Quick Text	 " ;
const unsigned char ds_13_2_1[] =	"Order Delivered " ;
const unsigned char ds_13_2_2[] =	"Sending GPS Loc." ;
const unsigned char ds_13_2_3[]	=	"Send help ASAP  " ;
const unsigned char ds_13_2_4[]	=	"Accident        " ;
const unsigned char ds_13_2_5[]	=	"Medical Emergenc" ;
const unsigned char ds_13_2_6[]	=	"Vehicle Problems" ;
const unsigned char	ds_13_2_7[]	=	"Flat Tire       " ;
const unsigned char ds_13_2_8[]	=	"Out of Gas      " ;
const unsigned char ds_13_2_9[]	=	"I am Lost       " ;
const unsigned char ds_13_2_10[]=	"Delivery Complet" ;
const unsigned char	ds_13_2_11[]=	"Arrived         " ;
const unsigned char ds_13_2_12[]=	"Returning       " ;
const unsigned char ds_13_2_13[]=	"Send Location   " ;
const unsigned char	ds_13_2_14[]=	"Yes             " ;
const unsigned char ds_13_2_15[]=	"No              " ;
const unsigned char ds_13_2_16[]=	"Returning 2 Base" ;

#define	P_QUICKCONFIG_MAX		9
#define	P_PANICALARMTIME_MAX	5
#define	P_PANICALARMREPEAT_MAX	6
#define	P_PANICALARMSOUND_MAX	3
#define	P_911CALLDELAY_MAX		6
#define	P_SPEAKERVOLUME_MAX		4
#define	P_GPSREPORT_MAX			7
#define	P_GPSPOWER_MAX			3
#define	P_SMSSERVICE_MAX		3
#define	P_SMSALERT_MAX			4
#define	P_CLOCKDISPLAY_MAX		2
#define	P_CLOCKTIMEZONE_MAX		2
#define	P_SMSQUICKTEXT_MAX		16

unsigned char ax ;

void	next_alternative(void)
{
	switch(g_parameter)
	{
		case 1 :	if(p_QuickConfig < P_QUICKCONFIG_MAX) ++p_QuickConfig ;
					else	p_QuickConfig = 1 ;
					break ;
		case 2 :	if(p_PanicAlarmTime < P_PANICALARMTIME_MAX) ++p_PanicAlarmTime ;
					else	p_PanicAlarmTime = 1 ;
					break ;
		case 3 :	if(p_PanicAlarmRepeat < P_PANICALARMREPEAT_MAX) ++p_PanicAlarmRepeat ;
					else	p_PanicAlarmRepeat = 1 ;
					break ;
		case 4 :	if(p_PanicAlarmSound < P_PANICALARMSOUND_MAX) ++p_PanicAlarmSound ;
					else	p_PanicAlarmSound = 1 ;
					break ;
		case 5 :	if(p_911CallDelay < P_911CALLDELAY_MAX) ++p_911CallDelay ;
					else	p_911CallDelay = 1 ;
					break ;
		case 6 :	if(p_SpeakerVolume < P_SPEAKERVOLUME_MAX) ++p_SpeakerVolume ;
					else	p_SpeakerVolume = 1 ;
					break ;
		case 7 :	if(p_GPSReport < P_GPSREPORT_MAX) ++p_GPSReport ;
					else	p_GPSReport = 1 ;
					break ;
		case 8 :	if(p_GPSPower < P_GPSPOWER_MAX) ++p_GPSPower ;
					else	p_GPSPower = 1 ;
					break ;
		case 9 :	if(p_SMSService < P_SMSSERVICE_MAX) ++p_SMSService ;
					else	p_SMSService = 1 ;
					break ;
		case 10 :	if(p_SMSAlert < P_SMSALERT_MAX) ++p_SMSAlert ;
					else	p_SMSAlert = 1 ;
					break ;
		case 11 :	if(p_ClockDisplay < P_CLOCKDISPLAY_MAX)	++p_ClockDisplay ;
					else	p_ClockDisplay = 1 ;
					break ;
		case 12 :	if(p_ClockTimeZone < P_CLOCKTIMEZONE_MAX) ++p_ClockTimeZone ;
					else	p_ClockTimeZone = 1 ;
					break ;
		case 13 :	if(p_SMSQuickText < P_SMSQUICKTEXT_MAX)	++p_SMSQuickText ;
					else	p_SMSQuickText = 1 ;
					break ;
	}
}
void	prev_alternative(void)
{
	switch(g_parameter)
	{
		case 1 :	if(p_QuickConfig > 1) --p_QuickConfig ;
					else	p_QuickConfig = P_QUICKCONFIG_MAX ;
					break ;
		case 2 :	if(p_PanicAlarmTime > 1) --p_PanicAlarmTime ;
					else	p_PanicAlarmTime = P_PANICALARMTIME_MAX ;
					break ;
		case 3 :	if(p_PanicAlarmRepeat > 1) --p_PanicAlarmRepeat ;
					else	p_PanicAlarmRepeat = P_PANICALARMREPEAT_MAX ;
					break ;
		case 4 :	if(p_PanicAlarmSound > 1) --p_PanicAlarmSound ;
					else	p_PanicAlarmSound = P_PANICALARMSOUND_MAX ;
					break ;
		case 5 :	if(p_911CallDelay > 1) --p_911CallDelay ;
					else	p_911CallDelay = P_911CALLDELAY_MAX ;
					break ;
		case 6 :	if(p_SpeakerVolume > 1) --p_SpeakerVolume ;
					else	p_SpeakerVolume = P_SPEAKERVOLUME_MAX ;
					break ;
		case 7 :	if(p_GPSReport > 1) --p_GPSReport ;
					else	p_GPSReport = P_GPSREPORT_MAX ;
					break ;
		case 8 :	if(p_GPSPower > 1) --p_GPSPower ;
					else	p_GPSPower = P_GPSPOWER_MAX ;
					break ;
		case 9 :	if(p_SMSService > 1) --p_SMSService ;
					else	p_SMSService = P_SMSSERVICE_MAX ;
					break ;
		case 10 :	if(p_SMSAlert > 1) --p_SMSAlert ;
					else	p_SMSAlert = P_SMSALERT_MAX ;
					break ;
		case 11 :	if(p_ClockDisplay > 1) --p_ClockDisplay ;
					else	p_ClockDisplay = P_CLOCKDISPLAY_MAX ;
					break ;
		case 12 :	if(p_ClockTimeZone > 1) --p_ClockTimeZone ;
					else	p_ClockTimeZone = P_CLOCKTIMEZONE_MAX ;
					break ;
		case 13 :	if(p_SMSQuickText > 1)	--p_SMSQuickText ;
					else	p_SMSQuickText = P_SMSQUICKTEXT_MAX ;
					break ;
	}
}
void	dp1_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_QuickConfig)
	{
		default :	p_QuickConfig = 1 ;	/* Default is case 1	*/
		case 1:		while(ds_1_2_1[ax] != '\0') d_putch(ds_1_2_1[ax++])	; break ;
		case 2:		while(ds_1_2_2[ax] != '\0') d_putch(ds_1_2_2[ax++]) ; break ;
		case 3:		while(ds_1_2_3[ax] != '\0') d_putch(ds_1_2_3[ax++]) ; break ;
		case 4:		while(ds_1_2_4[ax] != '\0') d_putch(ds_1_2_4[ax++]) ; break ;
		case 5:		while(ds_1_2_5[ax] != '\0') d_putch(ds_1_2_5[ax++]) ; break ;
		case 6:		while(ds_1_2_6[ax] != '\0') d_putch(ds_1_2_6[ax++]) ; break ;
		case 7:		while(ds_1_2_7[ax] != '\0') d_putch(ds_1_2_7[ax++]) ; break ;
		case 8:		while(ds_1_2_7[ax] != '\0') d_putch(ds_1_2_8[ax++]) ; break ;
		case 9:		while(ds_1_2_7[ax] != '\0') d_putch(ds_1_2_9[ax++]) ; break ;
	}
}
void	dp2_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_PanicAlarmTime)
	{
		default :	p_PanicAlarmTime = 1 ;	/* Default is case 1	*/
		case 1:		while(ds_2_2_1[ax] != '\0') d_putch(ds_2_2_1[ax++]) ; break ;
		case 2:		while(ds_2_2_2[ax] != '\0') d_putch(ds_2_2_2[ax++]) ; break ;
		case 3:		while(ds_2_2_3[ax] != '\0') d_putch(ds_2_2_3[ax++]) ; break ;
		case 4:		while(ds_2_2_4[ax] != '\0') d_putch(ds_2_2_4[ax++]) ; break ;
		case 5:		while(ds_2_2_5[ax] != '\0') d_putch(ds_2_2_5[ax++]) ; break ;
	}
}	
void	dp3_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_PanicAlarmRepeat)
	{
		default :	p_PanicAlarmRepeat = 1 ;	/* Default is case 1	*/
		case 1:		while(ds_3_2_1[ax] != '\0') d_putch(ds_3_2_1[ax++]) ; break ;
		case 2:		while(ds_3_2_2[ax] != '\0') d_putch(ds_3_2_2[ax++]) ; break ;
		case 3:		while(ds_3_2_3[ax] != '\0') d_putch(ds_3_2_3[ax++]) ; break ;
		case 4:		while(ds_3_2_4[ax] != '\0') d_putch(ds_3_2_4[ax++]) ; break ;
		case 5:		while(ds_3_2_5[ax] != '\0') d_putch(ds_3_2_5[ax++]) ; break ;
		case 6:		while(ds_3_2_6[ax] != '\0') d_putch(ds_3_2_6[ax++]) ; break ;
	}
}
void	dp4_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_PanicAlarmSound)
	{
		default :	p_PanicAlarmSound = 1 ;	/* Default is case 1	*/
		case 1:		while(ds_4_2_1[ax] != '\0') d_putch(ds_4_2_1[ax++]) ; break ;
		case 2:		while(ds_4_2_2[ax] != '\0') d_putch(ds_4_2_2[ax++]) ; break ;
		case 3:		while(ds_4_2_3[ax] != '\0') d_putch(ds_4_2_3[ax++]) ; break ;
	}
}
void	dp5_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_911CallDelay)
	{
		default :	p_911CallDelay = 1 ;	/* Default is case 1	*/
		case 1:		while(ds_5_2_1[ax] != '\0') d_putch(ds_5_2_1[ax++]) ; break ;
		case 2:		while(ds_5_2_2[ax] != '\0') d_putch(ds_5_2_2[ax++]) ; break ;
		case 3:		while(ds_5_2_3[ax] != '\0') d_putch(ds_5_2_3[ax++]) ; break ;
		case 4:		while(ds_5_2_4[ax] != '\0') d_putch(ds_5_2_4[ax++]) ; break ;
		case 5:		while(ds_5_2_5[ax] != '\0') d_putch(ds_5_2_5[ax++]) ; break ;
		case 6:		while(ds_5_2_6[ax] != '\0') d_putch(ds_5_2_6[ax++]) ; break ;
	}
}
void	dp6_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_SpeakerVolume)
	{
		default :	p_SpeakerVolume = 1 ;	/* Default is case 1	*/
		case 1:		while(ds_6_2_1[ax] != '\0') d_putch(ds_6_2_1[ax++]) ; break ;
		case 2:		while(ds_6_2_2[ax] != '\0') d_putch(ds_6_2_2[ax++]) ; break ;
		case 3:		while(ds_6_2_3[ax] != '\0') d_putch(ds_6_2_3[ax++]) ; break ;
		case 4:		while(ds_6_2_4[ax] != '\0') d_putch(ds_6_2_4[ax++]) ; break ;
	}
}
void	dp7_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_GPSReport)
	{
		default :	p_GPSReport = 1 ;	/* default case is 1	*/
		case 1 :	while(ds_7_2_1[ax] != '\0') d_putch(ds_7_2_1[ax++]) ; break ;
		case 2 :	while(ds_7_2_2[ax] != '\0') d_putch(ds_7_2_2[ax++]) ; break ;
		case 3 :	while(ds_7_2_3[ax] != '\0') d_putch(ds_7_2_3[ax++]) ; break ;
		case 4 :	while(ds_7_2_4[ax] != '\0') d_putch(ds_7_2_4[ax++]) ; break ;
		case 5 :	while(ds_7_2_5[ax] != '\0') d_putch(ds_7_2_5[ax++]) ; break ;
		case 6 :	while(ds_7_2_6[ax] != '\0') d_putch(ds_7_2_6[ax++]) ; break ;
		case 7 :	while(ds_7_2_7[ax] != '\0') d_putch(ds_7_2_7[ax++]) ; break ;
	}
}
void	dp8_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_GPSPower)
	{
		default :	p_GPSPower = 1 ;	/* default case is 1	*/
		case 1 :	while(ds_8_2_1[ax] != '\0') d_putch(ds_8_2_1[ax++]) ; break ;
		case 2 :	while(ds_8_2_2[ax] != '\0') d_putch(ds_8_2_2[ax++]) ; break ;
		case 3 :	while(ds_8_2_3[ax] != '\0') d_putch(ds_8_2_3[ax++]) ; break ;
	}
}
void	dp9_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_SMSService)
	{
		default :	p_SMSService = 1 ;
		case 1 :	while(ds_9_2_1[ax] != '\0') d_putch(ds_9_2_1[ax++]) ; break ;
		case 2 :	while(ds_9_2_2[ax] != '\0') d_putch(ds_9_2_2[ax++]) ; break ;
		case 3 :	while(ds_9_2_3[ax] != '\0') d_putch(ds_9_2_3[ax++]) ; break ;
	}
}
void	dp10_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_SMSAlert)
	{
		default :	p_SMSAlert = 1 ;
		case 1:		while(ds_10_2_1[ax] != '\0') d_putch(ds_10_2_1[ax++]) ; break ;
		case 2:		while(ds_10_2_2[ax] != '\0') d_putch(ds_10_2_2[ax++]) ; break ;
		case 3:		while(ds_10_2_3[ax] != '\0') d_putch(ds_10_2_3[ax++]) ; break ;
		case 4:		while(ds_10_2_4[ax] != '\0') d_putch(ds_10_2_4[ax++]) ; break ;
	}
}
void	dp11_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_ClockDisplay)
	{
		default :	p_ClockDisplay = 1 ;
		case 1:		while(ds_11_2_1[ax] != '\0') d_putch(ds_11_2_1[ax++]) ; break ;
		case 2:		while(ds_11_2_2[ax] != '\0') d_putch(ds_11_2_2[ax++]) ; break ;
	}
}
void	dp12_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_ClockTimeZone)
	{
		default :	p_ClockTimeZone = 1 ;
		case 1:		while(ds_12_2_1[ax] != '\0') d_putch(ds_12_2_1[ax++]) ; break ;
		case 2:		while(ds_12_2_2[ax] != '\0') d_putch(ds_12_2_2[ax++]) ; break ;
	}
}
void	dp13_alternatives(void)
{
	ax = 0 ;
	d_gotoxy(1,2) ;
	switch(p_SMSQuickText)
	{
		default :	p_SMSQuickText = 1 ;
		case 1 :	while(ds_13_2_1[ax]  != '\0') d_putch(ds_13_2_1[ax++])  ; break ;
		case 2 :	while(ds_13_2_2[ax]  != '\0') d_putch(ds_13_2_2[ax++])  ; break ;
		case 3 :	while(ds_13_2_3[ax]  != '\0') d_putch(ds_13_2_3[ax++])  ; break ;
		case 4 :	while(ds_13_2_4[ax]  != '\0') d_putch(ds_13_2_4[ax++])  ; break ;
		case 5 :	while(ds_13_2_5[ax]  != '\0') d_putch(ds_13_2_5[ax++])  ; break ;
		case 6 :	while(ds_13_2_6[ax]  != '\0') d_putch(ds_13_2_6[ax++])  ; break ;
		case 7 :	while(ds_13_2_7[ax]  != '\0') d_putch(ds_13_2_7[ax++])  ; break ;
		case 8 :	while(ds_13_2_8[ax]  != '\0') d_putch(ds_13_2_8[ax++])  ; break ;
		case 9 :	while(ds_13_2_9[ax]  != '\0') d_putch(ds_13_2_9[ax++])  ; break ;
		case 10 :	while(ds_13_2_10[ax] != '\0') d_putch(ds_13_2_10[ax++]) ; break ;
		case 11 :	while(ds_13_2_11[ax] != '\0') d_putch(ds_13_2_11[ax++]) ; break ;
		case 12 :	while(ds_13_2_12[ax] != '\0') d_putch(ds_13_2_12[ax++]) ; break ;
		case 13 :	while(ds_13_2_13[ax] != '\0') d_putch(ds_13_2_13[ax++]) ; break ;
		case 14 :	while(ds_13_2_14[ax] != '\0') d_putch(ds_13_2_14[ax++]) ; break ;
		case 15 :	while(ds_13_2_15[ax] != '\0') d_putch(ds_13_2_15[ax++])	; break ;
		case 16 :	while(ds_13_2_16[ax] != '\0') d_putch(ds_13_2_16[ax++]) ; break ;
	}

}
		
void	display_parameter(void)
{
	ax = 0 ;
	d_gotoxy(1,1) ;
	switch(g_parameter)
	{
		case 0:		break ;
		case 1:		while(ds_1_1_1[ax] 	!= '\0') d_putch(ds_1_1_1[ax++])  ;
					dp1_alternatives() ;
					break ;
		case 2:		while(ds_2_1_1[ax] 	!= '\0') d_putch(ds_2_1_1[ax++])  ;
					dp2_alternatives() ;
					break ;
		case 3: 	while(ds_3_1_1[ax] 	!= '\0') d_putch(ds_3_1_1[ax++])  ;
					dp3_alternatives() ;
					break ;
		case 4:		while(ds_4_1_1[ax] 	!= '\0') d_putch(ds_4_1_1[ax++])  ;
					dp4_alternatives() ;
					break ;
		case 5:		while(ds_5_1_1[ax] 	!= '\0') d_putch(ds_5_1_1[ax++])  ;
					dp5_alternatives() ;
					break ;
		case 6: 	while(ds_6_1_1[ax] 	!= '\0') d_putch(ds_6_1_1[ax++])  ;
					dp6_alternatives() ;
					break ;
		case 7: 	while(ds_7_1_1[ax] 	!= '\0') d_putch(ds_7_1_1[ax++])  ;
					dp7_alternatives() ;
					break ;
		case 8:	 	while(ds_8_1_1[ax] 	!= '\0') d_putch(ds_8_1_1[ax++])  ;
					dp8_alternatives() ;
					break ;
		case 9: 	while(ds_9_1_1[ax] 	!= '\0') d_putch(ds_9_1_1[ax++])  ;
					dp9_alternatives() ;
					break ;
		case 10:	while(ds_10_1_1[ax] != '\0') d_putch(ds_10_1_1[ax++]) ;
					dp10_alternatives() ;
					break ;
		case 11:	while(ds_11_1_1[ax] != '\0') d_putch(ds_11_1_1[ax++]) ;
					dp11_alternatives() ;
					break ;
		case 12:	while(ds_12_1_1[ax] != '\0') d_putch(ds_12_1_1[ax++]) ;
					dp12_alternatives() ;
					break ;
		case 13:	while(ds_13_1_1[ax] != '\0') d_putch(ds_13_1_1[ax++]) ;
					dp13_alternatives() ;
					break ;
	}
}

void	d_home(void)
{
	write_DCR(DISPLAY_PAGE_ADDRESS+0) ;
	write_DCR(DISPLAY_COLUMN_H+1) ;
	write_DCR(DISPLAY_COLUMN_L+0) ;
}

void	d_clear_eol(void)
{
	for( B = 0; B < 16; B++)
	{
		write_DD0() ;		/* Write 6 zeros athe the current display location	*/
	}
}

void	d_clear(void)
{
	d_home() ;		d_clear_eol() ;
	d_gotoxy(1,2) ;	d_clear_eol() ;
	d_home() ;
}



void	d_gotoxy(unsigned char x, unsigned char y)
{
	/*	y must be in the range [1..2]	*/
	/*	x must be in the range [1..16]	*/
	if((y < 1) || (y > 2))  y = 1 ;
	write_DCR(DISPLAY_PAGE_ADDRESS + (y - 1)) ;
	if((x < 1) || (x > 16)) x = 1 ;
	B = ((x - 1) * 6) + 16 ;
	write_DCR(DISPLAY_COLUMN_H + (B >> 4)) ;
	write_DCR(DISPLAY_COLUMN_L + (B & 15)) ;
}

void	d_tod(void)
{	/* Display Time of Day	*/
	d_gotoxy(1,2) ;
	d_putch(gsm_Clock[9])  ; 	d_putch(gsm_Clock[10]) ;
	d_putch(gsm_Clock[11]) ;
	d_putch(gsm_Clock[12]) ;	d_putch(gsm_Clock[13]) ;
	d_putch(gsm_Clock[14]) ;
	d_putch(gsm_Clock[15]) ;	d_putch(gsm_Clock[16]) ;
}
#define	S1		gsm_Clock[16]
#define	S10		gsm_Clock[15]
#define	M1		gsm_Clock[13]
#define	M10		gsm_Clock[12]
#define	H1		gsm_Clock[10]
#define	H10		gsm_Clock[9]

void	d_tod_plus1(void)
{	/* Display Time of Day Plus one	*/
	if(S1 < '9')	{ ++S1 ; }
	else
	{	{ S1 = '0' ; }
		if(S10 < '5')	{ ++S10 ; }
		else
		{	{ S10 = '0' ; }
			if(M1 < '9')	{ ++M1 ; }
			else
			{	{ M1 = '0' ; }
				if(M10 < '5')	{ ++M10 ; }
				else
				{	{ M10 = '0' ; }
					if((H10 == '2') && (H1 == '3'))
					{	H10 = H1 = '0' ; }
					else
					{
						if(H1 < '9')	{ ++H1 ; }
						else
						{	{ H1 = '0' ; }
							if(H10 < '2')	{ ++H10 ; }
							else			{ H10 = '0' ; }
						}
					}
				}
			}
		}
	}
}

void	d_clock(void)
{
	d_gotoxy(1,2) ;	d_clear_eol() ;
	d_gotoxy(1,2) ;
	d_putch(g_clock[0]) ;
	d_putch(g_clock[1]) ;
	d_putch(g_clock[2]) ;
	d_putch(g_clock[3]) ;
	d_putch(g_clock[4]) ;
}

void	d_clock_minus1(void)
{
	if((g_clock[0] == '0') && (g_clock[1] == '0') && (g_clock[3] == '0') && (g_clock[4] == '0'))
	{
		CLOCK_ZERO = 1 ;
		return ;
	}
	if((g_clock[4] > '0') && (g_clock[4] <= '9'))
	{
		--g_clock[4] ;
		d_gotoxy(5,2) ;
		d_putch(g_clock[4]) ;
	}
	else
	{
		g_clock[4] = '9' ;
		d_gotoxy(5,2) ;
		d_putch(g_clock[4]) ;
		if((g_clock[3] > '0') && (g_clock[3] <= '5'))
		{
			--g_clock[3] ;
			d_gotoxy(4,2) ;
			d_putch(g_clock[3]) ;
		}
		else
		{
			g_clock[3] = '5' ;
			d_gotoxy(4,2) ;
			d_putch(g_clock[3]) ;
			if((g_clock[1] > '0') && (g_clock[1] <= '9'))
			{
				--g_clock[1] ;
				d_gotoxy(2,2) ;
				d_putch(g_clock[1]) ;
			}
			else
			{
				g_clock[1] = '9' ;
				d_gotoxy(2,2) ;
				d_putch(g_clock[1]) ;
				if((g_clock[0] > '0') && (g_clock[0] <= '5'))
				{
					--g_clock[0];
					d_gotoxy(1,2) ;
					d_putch(g_clock[0]) ;
					
				}
				else
				{
				}				
			}
		}
	}
}

void	d_latitude(void)
{
	d_putch('L') ;
	d_putch('A') ;
	d_putch('T') ;
	d_putch(' ') ;
	d_putch(' ') ;
/*	Now output the variable part	*/
	d_putch(g_latitude[0]) ;	
	d_putch(g_latitude[1]) ;	
	d_putch(g_latitude[2]) ;	
	d_putch(g_latitude[3]) ;	
	d_putch(g_latitude[4]) ;	
	d_putch(g_latitude[5]) ;	
	d_putch(g_latitude[6]) ;	
	d_putch(g_latitude[7]) ;	
	d_putch(g_latitude[8]) ;	
	d_putch(' ') ;
	d_putch(g_latitudeIndicator) ;
}

void	d_savedlatitude(void)
{
	d_putch('L') ; 
	d_putch('A') ; 
	d_putch('T') ; 
	d_putch(' ') ; 
	d_putch(' ') ; 
/*	Now output the variable part	*/
	d_putch(g_savedlatitude[0]) ;	
	d_putch(g_savedlatitude[1]) ;	
	d_putch(g_savedlatitude[2]) ;	
	d_putch(g_savedlatitude[3]) ;	
	d_putch(g_savedlatitude[4]) ;	
	d_putch(g_savedlatitude[5]) ;	
	d_putch(g_savedlatitude[6]) ;	
	d_putch(g_savedlatitude[7]) ;	
	d_putch(g_savedlatitude[8]) ;	
	d_putch(' ') ;
	d_putch(g_savedlatitudeIndicator) ;
}

void	d_longitude(void)
{
	d_putch('L') ;
	d_putch('O') ;
	d_putch('N') ;
	d_putch(' ') ;
	d_putch(g_longitude[0]) ;	
	d_putch(g_longitude[1]) ;	
	d_putch(g_longitude[2]) ;	
	d_putch(g_longitude[3]) ;	
	d_putch(g_longitude[4]) ;	
	d_putch(g_longitude[5]) ;	
	d_putch(g_longitude[6]) ;	
	d_putch(g_longitude[7]) ;	
	d_putch(g_longitude[8]) ;	
	d_putch(g_longitude[9]) ;	
	d_putch(' ') ;
	d_putch(g_longitudeIndicator) ;
}

void	d_savedlongitude(void)
{
	d_putch('L') ;
	d_putch('O') ;
	d_putch('N') ;
	d_putch(' ') ;
	d_putch(g_savedlongitude[0]) ;	
	d_putch(g_savedlongitude[1]) ;	
	d_putch(g_savedlongitude[2]) ;	
	d_putch(g_savedlongitude[3]) ;	
	d_putch(g_savedlongitude[4]) ;	
	d_putch(g_savedlongitude[5]) ;	
	d_putch(g_savedlongitude[6]) ;	
	d_putch(g_savedlongitude[7]) ;	
	d_putch(g_savedlongitude[8]) ;	
	d_putch(g_savedlongitude[9]) ;	
	d_putch(' ') ;
	d_putch(g_savedlongitudeIndicator) ;
}

void	d_signalQuality(void)
{
	d_gotoxy(12,2) ;
	d_putch(ANTENNA) ;
	if(g_CSQ == 99)	/* Undetectable Signal Quality	*/
	/* Display as a pair of dashes					*/
	{	d_putch('-') ; d_putch('-') ;	}
	else if(g_CSQ < 23)	/* 0 to 3 bars		*/
	{
		if(g_CSQ <= 1)			{ d_putch(' ') ;	d_putch(' ') ; }	/* 0 bars	*/
		else if(g_CSQ <= 8)		{ d_putch(_1BAR) ;	d_putch(' ') ; }	/* 1 bar	*/
		else if(g_CSQ <= 15)	{ d_putch(_2BARS) ;	d_putch(' ') ; }	/* 2 bars	*/
		else if(g_CSQ <= 22)	{ d_putch(_3BARS) ; d_putch(' ') ; }	/* 3 bars	*/
		else					{ d_putch('~') ;	d_putch('~') ; }
	}
	else if(g_CSQ < 32)	/* 4 or 5 bars	*/
	{
		d_putch(_3BARS) ;
		if(g_CSQ <= 29)			{ d_putch(_4BARS) ; }
		else if(g_CSQ <= 31)	{ d_putch(_5BARS) ; }
		else					{ d_putch('~') ;	d_putch('~') ; }
	}
	else
	/* Any other unexpected value is a pair of tildes			*/
	{	d_putch('~') ; d_putch('~') ;	}
}

void	d_batteryCapacity(void)
{
unsigned char	bc ;

	d_gotoxy(10,2) ;
	switch(g_SBC)
	{
		case 0 :	bc = BATTERY_00  ; break ;
		case 20 :	bc = BATTERY_20  ; break ;
		case 40 :	bc = BATTERY_40  ; break ;
		case 60 :	bc = BATTERY_60  ; break ;
		case 80 :	bc = BATTERY_80  ; break ;
		case 100 :	bc = BATTERY_100 ; break ;
		default :	bc = '~' ;         break ;	
	}
	d_putch(bc) ;
}				