/*
**  externs.h
**  (c)Huron Net Works, Inc., 1997-2005
**
**  External Definitions
**
**  TABS 5, 9
*/

extern void classRouter(void) ;

		/*	dispio.s03						*/
extern void write_DCR(unsigned char) ;
extern void write_DCRI(unsigned char) ;
extern void write_DDR(unsigned char) ;
extern void	write_DD0(void) ;
extern unsigned char read_DSR(void) ;
extern unsigned char read_DDR(void) ;
extern void	d_putch(unsigned char) ;		


		/*	display.c						*/
extern void	display_parameter(void) ;
extern void next_alternative(void) ;
extern void prev_alternative(void) ;		
extern void	d_home(void) ;
extern void d_clear(void) ;
extern void	d_moveUp(void) ;
extern void	d_moveDown(void) ;
extern void	d_moveLeft(void) ;
extern void	d_moveRight(void) ;
extern void	d_gotoxy(unsigned char, unsigned char) ;
extern void	d_clock(void) ;
extern void	d_clock_minus1(void) ;
extern void	d_latitude(void) ;
extern void	d_savedlatitude(void) ;
extern void	d_longitude(void) ;
extern void d_savedlongitude(void) ;
extern void	d_clear_eol(void) ;
extern void	d_tod(void) ;
extern void	d_tod_plus1(void) ;
extern void	d_signalQuality(void) ;
extern void	d_batteryCapacity(void) ;

        /*  eeprom.c  -- EEPROM Driver      */

extern void				EEPROM_WRITE(void) ;
extern void				EE_WRITEI(void) ;
extern void				EE_WRITEP(void) ;
extern unsigned char	EEPROM_READ(void) ;
extern unsigned char	EE_READI(void) ;
extern unsigned char	EE_READP(void) ;

		/*	gsm.c	-- GSM UART Module			*/
extern unsigned char gsm_RxDeQueue(void) ;
extern void	gsm_sendATR(void) ;
extern void	gsm_sendATPCCLKE(void) ;
extern void gsm_sendATD(void) ;
extern void	gsm_Init(void) ;
extern void	gsm_TxEnQueue(unsigned char) ;
extern void	gsmMonitor(void) ;
extern void	gsm_Parser(void) ;

		/*	gps.c	-- GPS UART Module			*/
extern void	gps_Init(void) ;
extern void gps_Invalid(void) ;
extern void	gpsMonitor(void) ;
extern void	gps_sendDisableGGA(void) ;
extern void	gps_sendDisableGLL(void) ;
extern void	gps_sendDisableGSA(void) ;
extern void	gps_sendDisableGSV(void) ;

		/*	init.c	--	Initialization			*/
extern void	LP_INIT(void) ;
extern void	MPU_INIT(void) ;		
		
		/*	keyboard.c	--	Keyboard Driver		*/
extern void	kbd_Init(void) ;
extern void	getch(void) ;

		/*	led.c -- Bicolor LED Driver			*/
extern void	led_update(void) ;

        /*  main.c    -- Application Code		*/

extern void main(void);

		/*	monitor.c	-- Serial Port Monitor		*/

extern void spMonitor(void) ;
extern void spMonitorInit(void) ;
extern void panic_down(void) ;
extern void panic_up(void) ;
extern void putch(unsigned char) ;
extern void puthex(unsigned char) ;
extern void putint(unsigned int) ;
		
		/*  reset.s    -- Reset Initialization		*/

extern void	reloadTimer0(void) ;
extern void	reloadTimer1(void) ;
extern void	loadTickTimer(void) ;
extern void reloadTickTimer(void) ;
extern void	loadWakeupTimer(void) ;
extern void	reloadWakeupTimer(void) ;
extern void	idle(void) ;

		/*	sport.c		-- Serial Port Driver		*/
extern void	sp_Init(void) ;
extern void	sp_TxEnQueue(unsigned char) ;
extern unsigned char	sp_RxDeQueue(void) ;		

/*
**  Global Variables
*/

#define		GLOBAL	extern
#define		I(x)	
#include	"ramvars.c"
