void	gsmMonitor(void)
{
unsigned char ch ;

	if(gsmEcho == 0)
	{
		switch(gsm_state)
		{
			case GSM_NOP :	/* This is a do nothing state	*/
				nCall = 0 ;
				EC = 0 ; if(g_linkTime == 0)
				{
					if(gsmCall == 1)
					{
						gsm_state = GSM_SENDATPCMGF ;
					}
					else
					{
						gsm_state = GSM_IDLE ;
					}
				}
				EC = 1 ;		
				break ;
			case GSM_SENDATPCMGF :
				/* Select SMS Text Message Format						*/
				/* 0 = PDU Mode											*/
				/* 1 = Text Mode										*/
				if(gsmTXPEND == 0)	/* 1 if there is a command pending	*/
				{
					gsm_bufferClaim() ;
					gsm_maxtoken = 1 ;
					gsm_ATRetry = 1 ;
					gsm_sendATPCMGF() ;		/* Send at+cmgf=1							*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;			/* Set the TX PENDING FLAG					*/
				}
#if	0
				switch(gsm_decodeResponse())
				{
					default :
					case '\x00' :		/* Not Done yet				*/
										break ;
					case '\x01'	:		/* This is an OK response	*/
										gsmTXPEND = 0 ;
										EC = 0 ; g_linkTime = 0 ;
										EC = 1 ;
										gsm_state = GSM_SENDATPCMEE ;
										break ;
					case '\x02' :		/* This is an ERROR response	*/
										gsmTXPEND = 0 ;
										EC = 0 ; g_linkTime = 0 ;
										EC = 1 ;
										if(gsm_ATRetry > 0)	--gsm_ATRetry ;
										else				gsm_state = GSM_SENDATPCMEE ;
										break ;
				}
				EC = 0 ; if((g_linkTime == 0) && (gsmTXPEND == 1))
				{
					gsmTXPEND = 0 ;
					gsm_state = GSM_SENDATPCMEE ;
				}
				EC = 1 ;
#endif
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_SENDATPCMEE ;
				}
				EC = 1 ;
				break ;
			case GSM_SENDATPCNMI :
				/* Select new SMS Message Indications					*/
				if(gsmTXPEND == 0)	/* 1 if there is a command pending	*/
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 1 ;
					gsm_maxtoken = 1 ;
					gsm_sendATPCNMI() ;		/* Send at+cnmi=1,1							*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;			/* Set the TX PENDING FLAG					*/
				}
#if	0
				switch(gsm_decodeResponse())
				{
					default :
					case '\x00' :		/* Not Done yet				*/
										break ;
					case '\x01'	:		/* This is an OK response	*/
										gsmTXPEND = 0 ;
										EC = 0 ; g_linkTime = 0 ;
										EC = 1 ;
										gsm_state = GSM_SENDATPCMGS ;
										break ;
					case '\x02' :		/* This is an ERROR response	*/
										gsmTXPEND = 0 ;
										EC = 0 ; g_linkTime = 0 ;
										EC = 1 ;
										if(gsm_ATRetry > 0)	--gsm_ATRetry ;
										else				gsm_state = GSM_SENDATPCMGS ;
										break ;
				}
				EC = 0 ; if((g_linkTime == 0) && (gsmTXPEND == 1))
				{
					gsmTXPEND = 0 ;
					gsm_state = GSM_SENDATPCMGS ;
				}
				EC = 1 ;
#endif
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_SENDATPCMGS ;
				}
				EC = 1 ;
								
				break ;
			case GSM_SENDATPCMGS :
				/* Send an SMS Command								*/
				if(gsmTXPEND == 0)	/* 1 if there is a command pending	*/
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 3 ;
					gsm_maxtoken = 2 ;
					gsm_sendATPCMGS() ;		/* Send at+cmgs	to dial the phone			*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;			/* Set the TX PENDING FLAG					*/
				}
				if(gsmRCMP == 1)
				{
					dumpResponse() ;
					if(	(gsmResponse[gsm_token[1]]		== '>') &&
						(gsmResponse[gsm_token[1]+1]	== ' ') )
					{
						gsmTXPEND = 0 ;
						EC = 0 ; g_linkTime = 0 ;
						EC = 1 ;
						gsm_state = GSM_SENDSMSTEXT ;
					}
					else
					{
						gsmTXPEND = 0 ;
						EC = 0 ; g_linkTime = 0 ;
						EC = 1 ;
						if(gsm_ATRetry > 0)	--gsm_ATRetry ;
						else				gsm_state = GSM_SENDSMSTEXT ;
					}
				}
#if	0										 
				EC = 0 ; if((g_linkTime == 0) && (gsmTXPEND == 1))
				{
					gsmTXPEND = 0 ;
					gsm_state = GSM_SENDSMSTEXT ;
				}
				EC = 1 ;
#endif				
				break ;
			case GSM_SENDSMSTEXT :
				/* Send SMS Text		*/
				if(gsmTXPEND == 0)	/* 1 if there is a command pending	*/
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 0 ;
					gsm_maxtoken = 6 ;
					gsm_sendSMSTEXT() ;		/* Send at+cmgs	to dial the phone			*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;			/* Set the TX PENDING FLAG					*/
					++nCall ;
				}
				EC = 0  ; if((g_linkTime == 0))
				{
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_SHUTDOWN ;
				}
				EC = 1 ;				
				break ;
			case GSM_WAIT :			
				EC = 0 ; if(g_linkTime == 0)
				{
					gsm_state = GSM_SHUTDOWN ;
				}
				EC = 1 ;
				break ;
			case GSM_SHUTDOWN :
				if(nCall > 2)
				{
					gsm_bufferClaim() ;
#if	0
/*	Only do the shutdown if we are trying to save power	*/
					gsm_sendSHUTDOWN() ;
#endif						
					gsm_state = GSM_MODEMOFF ;
				}
				else
				{
					gsm_state = GSM_SENDATPCMGF ;
				}
				break ;
			case GSM_MODEMOFF :
				EC = 0 ; if(g_linkTime == 0)
				{
					GSM_IGT = 1 ;
					gsmCall = 0 ;
					gsm_state = GSM_NOP ;
				}
				EC = 1 ;
				break ;
			case GSM_SENDATPCMEE :
				if(gsmTXPEND == 0)
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 1 ;
					gsm_maxtoken = 1 ;
					gsm_sendATPCMEE() ;		/* Send command at\r and start link timer	*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;		/* Set the TX PENDING FLAG					*/
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					dumpResponse() ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_SENDATPCMGS ;
				}
				EC = 1 ;
				break ;
			case GSM_SENDATR :
				if(gsmTXPEND == 0)
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 1 ;
					gsm_maxtoken = 1 ;
					gsm_sendATR() ;		/* Send command at\r and start link timer	*/
					gsmTXPEND = 1 ;		/* Set the TX PENDING FLAG					*/
				}
				switch(gsm_decodeResponse())
				{
					default :
					case '\x00' :		/* Not Done yet				*/
										break ;
					case '\x01'	:		/* This is an OK response	*/
										gsmTXPEND = 0 ;
										EC = 0 ; g_linkTime = 0 ;
										EC = 1 ;
										gsm_state = GSM_SETCLOCK ;
										break ;
					case '\x02' :		/* This is an ERROR response	*/
										gsmTXPEND = 0 ;
										EC = 0 ; g_linkTime = 0 ;
										EC = 1 ;
										if(gsm_ATRetry > 0)	--gsm_ATRetry ;
										else				gsm_state = GSM_SETCLOCK ;
										break ;
				}
				EC = 0 ; if((g_linkTime == 0) && (gsmTXPEND == 1))
				{	/* Command Timeout	*/
					gsmTXPEND = 0 ;
					gsm_state = GSM_SETCLOCK ;
				}
				EC = 1 ;
				break ;
			case GSM_SETCLOCK :
				if(gsmTXPEND == 0)
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 1 ;
					gsm_maxtoken = 2 ;
					gsm_sendATPCCLKE() ;	/* Send Command to set the clock	*/
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					gsmTXPEND = 0 ;
					gsm_state = GSM_SIGNAL ;
				}
				EC = 1 ;
				break ;
			case GSM_AUDIOMODE :
				if(gsmTXPEND == 0)
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 1 ;
					gsm_maxtoken = 2 ;
					gsm_sendATSNFS() ;	/* Send Command to set the Audio Mode	*/
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					gsmTXPEND = 0 ;
					gsm_state = GSM_AUDIOCHANNELS ;
				}
				EC = 1 ;
				break ;
			case GSM_AUDIOCHANNELS :
				if(gsmTXPEND == 0)
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 1 ;
					gsm_maxtoken = 2 ;
					gsm_sendATSAIC() ;	/* Send Command to set the Audio Mode	*/
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					gsmTXPEND = 0 ;
					gsm_state = GSM_SETCLOCK ;
				}
				EC = 1 ;
				break ;
			case GSM_SIGNAL :
				if(gsmTXPEND == 0)
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 1 ;
					gsm_maxtoken = 3 ;
					gsm_sendATPCSQ() ;	/* Send Command to check signal quality	*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0 ; if(g_linkTime == 0)
				{
					EC = 1 ;
					g_CSQ = gsm_signalQuality() ;
					dumpResponse() ;
					putch('C') ; putch('S') ; putch('Q') ; putch ('=') ;
					puthex(g_CSQ) ;
					putch('\r') ; putch('\n') ;
					gsmTXPEND = 0 ;
					gsm_state = GSM_BATTERY ;
				}
				EC = 1 ;
				break ;
			case GSM_BATTERY :
				if(gsmTXPEND == 0)
				{
					gsm_bufferClaim() ;
					gsm_ATRetry = 1 ;
					gsm_maxtoken = 3 ;
					gsm_sendATUSBCQ() ;		/* Send Command to check battery	*/
					EC = 0 ; g_intervalTimer = 0 ;
					EC = 1 ;
					gsmTXPEND = 1 ;
				}
				EC = 0  ; if(g_linkTime == 0)
				{
					EC = 1 ;
					g_SBC = gsm_batteryCapacity() ;
					dumpResponse() ;
					putch('S') ; putch('B') ; putch('C') ; putch('=') ;
					puthex(g_SBC) ;
					putch('\r') ; putch('\n') ;
					gsmTXPEND = 0 ;
					EC = 0 ; g_linkTime = 30000 ;
					EC = 1 ;
					gsm_state = GSM_IDLE ;
				}
				EC = 1 ;
				break ;
			case GSM_IDLE :
				EC = 0 ; if(g_linkTime == 0)
				{
					gsm_state = GSM_SIGNAL ;
				}
				else
				{
					if(gsmCall == 1)
					{
						gsm_state = GSM_SENDATPCMGF ;
					}
				}
				EC = 1 ;
			default :
				break ;
		}
		if(gsm_nRx > 0)
		{
			
			gsmResponse[gsm_x++] = ch = gsm_RxDeQueue() ;  
			gsmResponse[gsm_x] = '\0' ;
			putch(ch) ;
			switch(ch)
			{
				case '\n' :
					++gsm_newlines ;
					if(gsm_newlines == 1)
					{
							gsm_token[1] = gsm_x ;
					}
					else
					{
						if(gsm_newlines < 10)
						{
							gsm_token[gsm_newlines]		= gsm_x ;
							gsm_token[gsm_newlines+1]	= '\0' ;
						}
					}
					if(gsm_newlines > gsm_maxtoken)
					{
						gsmRCMP = 1 ;
						EC = 0 ; gsm_time = g_intervalTimer ;
						EC = 1 ;
					}
					break ;
				case ' ' :
					if(gsm_token[1] > 0)
					{
						if(gsmResponse[gsm_token[1]] == '>')
						{
							gsmRCMP = 1 ;
						}
					}
					break ;
				default :	
					break ;
			}
		}
	}
	else
	{
		if(gsm_nRx > 0)
		{
			putch(gsm_RxDeQueue() ) ;
		}
	}
}
