;
;	sfred2.inc
;	Definitions for SFR's in the AT89C51ED2
;
;	7 Jul 2005	-- Original
;

#define	P0      	080H
#define	SP          081H
#define	DPL         082H
#define	DPH         083H
#define PCON        087H

#define	TCON		088H
;---  TCON Bits ---
#define	TF1     	TCON.7
#define	TR1     	TCON.6
#define	TF0     	TCON.5
#define	TR0     	TCON.4
#define	IE1     	TCON.3
#define	IT1     	TCON.2
#define	IE0     	TCON.1
#define	IT0     	TCON.0

#define	TMOD        089H
#define	TL0         08AH
#define	TL1         08BH
#define	TH0         08CH
#define	TH1         08DH
#define	AUXR		08EH
#define	CKCON0		08Fh

#define	P1          090H
#define	CKRL		097H

#define	SCON        098H
;--- SCON Bits ----
#define	SM0     	SCON.7
#define	SM1     	SCON.6
#define	SM2     	SCON.5
#define	REN     	SCON.4
#define	TB8     	SCON.3
#define	RB8     	SCON.2
#define	TI      	SCON.1
#define	RI      	SCON.0

#define	SBUF        099H
#define	BRL  		09AH
#define	BDRCON   	09BH
#define	KBLS		09CH
#define	KBE			09DH
#define	KBF			09EH

#define	P2          0A0H
#define	AUXR1		0A2H
#define	WDTRST		0A6H
#define	WDTPRG 		0A7H 

#define	IEN0        0A8H
;--- IEN0 Bits -----
#define	EA   		IEN0.7
#define	EC   		IEN0.6
#define	ET2  		IEN0.5
#define	ES  		IEN0.4
#define	ET1 		IEN0.3
#define	EX1  		IEN0.2
#define	ET0 		IEN0.1
#define	EX0			IEN0.0

#define	SADDR		0A9H
#define	CKCON1		0AFH

#define	P3      	0B0H
;--- P3 Bits -------
#define	RD			P3.7
#define	WR			P3.6
#define	T1			P3.5
#define	T0			P3.4
#define	INT1		P3.3
#define	INT0		P3.2
#define	TXD			P3.1
#define	RXD			P3.0

#define	IEN1		0B1H
#define	IPL1		0B2H
#define	IPH1		0B3H
#define	IPH0		0B7H

#define	IPL0		0B8H
;--- IPL0 Bits -----
#define	PPCL		IPL0.6
#define	PT2L		IPL0.5
#define	PSL			IPL0.4
#define	PT1L		IPL0.3
#define	PX1L		IPL0.2
#define	PT0L		IPL0.1
#define	PX0L		IPL0.0

#define	SADEN		0B9H

#define	P4      	0C0H
#define	SPCON       0C3H
#define	SPSTA       0C4H
#define	SPDAT       0C5H
#define	P5BA		0C7H

#define	T2CON       0C8H
;--- T2CON bits ----
#define	TF2			T2CON.7
#define	EXF2		T2CON.6
#define	RCLK		T2CON.5
#define	TCLK		T2CON.4
#define	EXEN2		T2CON.3
#define	TR2			T2CON.2
#define	C_T2		T2CON.1
#define	CP_RL2		T2CON.0

#define	T2MOD	    0C9h
#define	RCAP2L      0CAH
#define	RCAP2H      0CBH
#define	TL2         0CCH
#define	TH2         0CDH

#define	PSW         0D0H
;--- PSW bits ------
#define	CY			PSW.7
#define	AC			PSW.6
#define	F0			PSW.5
#define	RS1			PSW.4
#define	RS0			PSW.3
#define	OV			PSW.2
#define	P			PSW.0

#define	FCON   	    0D1H
#define	EECON		0D2H

#define	CCON		0D8H
;--- CCON bits -----
#define	CF			CCON.7
#define	CR			CCON.6
#define	CCF4		CCON.4
#define	CCF3		CCON.3
#define	CCF2		CCON.2
#define	CCF1		CCON.1
#define	CCF0		CCON.0

#define	CMOD		0D9H
#define	CCAPM0		0DAH
#define	CCAPM1		0DBH
#define	CCAPM2		0DCH
#define	CCAPM3		0DDH
#define	CCAPM4		0DEH

#define	ACC         0E0H

#define	P5      	0E8H
#define	CL			0E9H
#define	CCAP0L		0EAH
#define	CCAP1L		0EBH
#define	CCAP2L		0ECH
#define	CCAP3L		0EDH
#define	CCAP4L		0EEH

#define	B           0F0H

#define	CH			0F9H
#define	CCAP0H		0FAH
#define	CCAP1H		0FBH
#define	CCAP2H		0FCH
#define	CCAP3H		0FDH
#define CCAP4H		0FEH
